__gnu_pbds::detail::binomial_heap< Value_Type, Cmp_Fn, _Alloc >(3)

NAME
__gnu_pbds::detail::binomial_heap< Value_Type, Cmp_Fn, _Alloc >

SYNOPSIS

Inherits __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >.

  Public Types
typedef base_type::allocator_type allocator_type
typedef base_type::cmp_fn cmp_fn
typedef base_type::const_iterator const_iterator
typedef base_type::const_pointer const_pointer
typedef base_type::const_reference const_reference
typedef _Alloc::difference_type difference_type
typedef base_type::iterator iterator
typedef base_type::point_const_iterator point_const_iterator
typedef base_type::point_iterator point_iterator
typedef base_type::pointer pointer
typedef base_type::reference reference
typedef _Alloc::size_type size_type
typedef Value_Type value_type

  Public Member Functions
binomial_heap (const binomial_heap &)
binomial_heap (const Cmp_Fn &)
iterator begin ()
const_iterator begin () const
void clear ()
bool empty () const
iterator end ()
const_iterator end () const
void erase (point_iterator)
template<typename Pred > size_type erase_if (Pred)
Cmp_Fn & get_cmp_fn ()
const Cmp_Fn & get_cmp_fn () const
void join (binomial_heap_base< Value_Type, Cmp_Fn, _Alloc > &)
size_type max_size () const
void modify (point_iterator, const_reference)
void pop ()
point_iterator push (const_reference)
size_type size () const
template<typename Pred > void split (Pred, binomial_heap_base< Value_Type, Cmp_Fn, _Alloc > &)
void swap (left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc > &)
const_reference top () const

  Protected Types
typedef base_type::node node
typedef alloc_traits::allocator_type node_allocator
typedef _Alloc::size_type node_metadata
typedef std::pair< node_pointer, node_pointer > node_pointer_pair

  Protected Member Functions
void actual_erase_node (node_pointer)
void bubble_to_top (node_pointer)
void clear_imp (node_pointer)
template<typename It > void copy_from_range (It, It)
void find_max ()
node_pointer get_new_node_for_insert (const_reference)
node_pointer prune (Pred)
void swap (binomial_heap_base< Value_Type, Cmp_Fn, _Alloc > &)
void swap_with_parent (node_pointer, node_pointer)
void to_linked_list ()
void value_swap (left_child_next_sibling_heap &)

  Static Protected Member Functions
static void make_child_of (node_pointer, node_pointer)
static node_pointer parent (node_pointer)

  Protected Attributes
node_pointer m_p_max
node_pointer m_p_root
size_type m_size

Detailed Description

  template<typename Value_Type, typename Cmp_Fn, typename _Alloc>
class __gnu_pbds::detail::binomial_heap< Value_Type, Cmp_Fn, _Alloc >" Binomial heap.

Definition at line 68 of file binomial_heap_.hpp.

Author

Generated automatically by Doxygen for libstdc++ from the source code.